diff --git a/src/providers/ogr/qgsogrprovider.cpp b/src/providers/ogr/qgsogrprovider.cpp
index 0893d88..c89971e 100644
--- a/src/providers/ogr/qgsogrprovider.cpp
+++ b/src/providers/ogr/qgsogrprovider.cpp
@@ -1127,7 +1127,7 @@ bool QgsOgrProvider::addAttributes( const QList<QgsField> &attributes )
         continue;
     }
 
-    OGRFieldDefnH fielddefn = OGR_Fld_Create( TO8( iter->name() ), type );
+    OGRFieldDefnH fielddefn = OGR_Fld_Create( mEncoding->fromUnicode( iter->name() ).constData(), type );
     OGR_Fld_SetWidth( fielddefn, iter->length() );
     OGR_Fld_SetPrecision( fielddefn, iter->precision() );
 
@@ -2070,7 +2070,7 @@ QGISEXTERN bool createEmptyDataSource( const QString &uri,
       if ( precision < 0 )
         precision = 3;
 
-      field = OGR_Fld_Create( TO8( it->first ), OFTReal );
+      field = OGR_Fld_Create( codec->fromUnicode(it->first).constData(), OFTReal );
       OGR_Fld_SetWidth( field, width );
       OGR_Fld_SetPrecision( field, precision );
     }
@@ -2079,7 +2079,7 @@ QGISEXTERN bool createEmptyDataSource( const QString &uri,
       if ( width < 0 || width > 10 )
         width = 10;
 
-      field = OGR_Fld_Create( TO8( it->first ), OFTInteger );
+      field = OGR_Fld_Create( codec->fromUnicode(it->first).constData(), OFTInteger );
       // limit to 10.  otherwise OGR sets it to 11 and recognizes as OFTDouble later
       OGR_Fld_SetWidth( field, width );
     }
@@ -2088,7 +2088,7 @@ QGISEXTERN bool createEmptyDataSource( const QString &uri,
       if ( width < 0 || width > 255 )
         width = 255;
 
-      field = OGR_Fld_Create( TO8( it->first ), OFTString );
+      field = OGR_Fld_Create( codec->fromUnicode(it->first).constData(), OFTString );
       OGR_Fld_SetWidth( field, width );
     }
     else
